Subject: Re: Data corruption issue with splice() on 2.6.27.10

From: Evgeniy Polyakov <[email-masked]>
Date: Wed, 7 Jan 2009 15:46:29 +0300

On Wed, Jan 07, 2009 at 11:42:46PM +1100, Herbert Xu ([email-masked]) wrote:
> > Doesn't your tcp fallbacks to kernel_sendmsg() without sg in
> > tcp_sendpage()? And then just feeds data into the stack the same way it
> > happens with send() i.e. by copying it.
> 
> Good point.  Did he check GSO though? GSO will always enable SG
> on the socket regardless of the netdev's setting.  And if the device
> started out with SG enabled then recent kernels will enable GSO
> by default.

Willy, what was the kernel you are tested no-accel behaviour and what
were the gso settings?
Can you add a simple single print into tcp_sendpage() to determine if
content was copied or fed into do_tcp_sendpages() otherwise?

-- 
	Evgeniy Polyakov